#!/bin/sh
# Copyright (C) 2016 O.S. Systems Software LTDA.
# Copyright (C) 2016 Freescale Semiconductor

export PATH="/sbin:/usr/sbin:/bin:/usr/bin"

usage() {
    cat <<EOF
    $0 [<openvt arguments>] [-- <weston options>]
EOF
}

## Module support
modules_dir=/usr/share/weston-start

# Add weston extra argument
add_weston_argument() {
	weston_args="$weston_args $1"
}

# Add openvt extra argument
add_openvt_argument() {
	openvt_args="$openvt_args $1"
}

if [ -n "$WAYLAND_DISPLAY" ]; then
	echo "ERROR: A Wayland compositor is already running, nested Weston instance is not supported yet."
	exit 1
fi
if [ -n "$DISPLAY" ]; then
	launcher="weston"
else
	launcher="weston-launch --"
fi

openvt_args="-s"
while [ -n "$1" ]; do
	if [ "$1" = "--" ]; then
		shift
		break
	fi
	openvt_args="$openvt_args $1"
	shift
done

weston_args=$*

# Load and run modules
if [ -d "$modules_dir" ]; then
	for m in "$modules_dir"/*; do
		# Skip backup files
		if [ "`echo $m | sed -e 's/\~$//'`" != "$m" ]; then
			continue
		fi

		# process module
		. $m
	done
fi

if test -z "$XDG_RUNTIME_DIR"; then
    export XDG_RUNTIME_DIR=/run/user/`id -u`
fi

if ! test -d "$XDG_RUNTIME_DIR"; then
    mkdir --parents $XDG_RUNTIME_DIR
    chown admin:admin $XDG_RUNTIME_DIR
    chmod 0700 $XDG_RUNTIME_DIR
fi

# Configuration file is generated based on sysparams
TMPCONFIG="$(mktemp /tmp/weston.ini-XXXXXX)"
/etc/weston/weston.ini.sh > ${TMPCONFIG}
if [ $? -ne 0 ]; then
	echo "ERROR: Failed writing weston configuration!"
	exit 1
fi
weston_args="$weston_args --config ${TMPCONFIG}"

# If lockscreen override file is present, then parse its content.
# When a lockscreen timeout is set (>0), override weston.ini configuration
# with command line argument.
if test -f "/etc/X11/app-defaults/XScreenSaver"; then
	WESTON_LOCKSCREEN_TIMEOUT=`awk 'BEGIN {FS=":"} {secs = ($2*3600 + $3*60 + $4); exit;} END {print secs}' /etc/X11/app-defaults/XScreenSaver`
	if [[ $WESTON_LOCKSCREEN_TIMEOUT -gt 0 ]]; then
		# Use minutes for time units in /etc/weston/lockscreen config file
		# Uncomment the second line when config file time unit is seconds.
		weston_args="$weston_args --idle-time $WESTON_LOCKSCREEN_TIMEOUT"
	fi
fi

# Enable double framebuffer and vsync on iMX6
export FB_MULTI_BUFFER=2

exec openvt $openvt_args -- $launcher $weston_args --log=/var/log/weston.log
